/*								*
	proxcfg.h						*
*/

#define SUCCESS 0
#define FAILURE 0xFF
#define CLEAR 0
#define SET 0xFF
#define FLAGSET 0x01

struct sockaddr thesock;
struct rl2_ioctl_info {
	unsigned short cmd;
	unsigned char *data;
};
struct MastersList
{
        unsigned_8      ChSubChannel;
        unsigned_8      Name[11];
        unsigned_8      Address[6];
};
char *nodetypes[]={"Station", "Alternate Master", "Master"};
char *roamtypes[]={"slow", "normal", "fast"};
char *macconfigtypes[]={"very light", "light", "normal"};
char *hoptypes[]={"100 ms", "200 ms", "400 ms", "20 ms"};
char *card_types[]={
	"Proxim RangeLAN2 7100 ISA Card",
	"Proxim RangeLAN2 630x mini-ISA Card",
	"Proxim RangeLAN2 6330 micro design-in Card",
	"Proxim RangeLAN2/Symphony PC Card",
	"Proxim Symphony 4100 PnP ISA Card",
	"Proxim Symphony 4110 PCI Card",
	"Proxim RangeLAN2 6333 micro jr Card",
	"Proxim HomeRF 6334 micro jr Card",
	"Proxim Symphony/HomeRF 6335 micro jr Card"
};
char *CardConfig[]={
	"RangeLAN2 (roaming)",
	"Symphony/HomeRF (no roaming)",
	"undefined 3",
	"undefined 4",
	"Windows CE",
	"undefined 5",
	"undefined 6",
	"undefined 7"
};

/* IOCTL's called via SIOCDEVPRIVATE */
enum {
	SET_LLDRESET,
	SET_NODETYPE, GET_NODETYPE,
	SET_DOMAIN, GET_DOMAIN,
	SET_SECID,
	SET_CHANNEL, GET_CHANNEL,
	SET_SUBCHANNEL, GET_SUBCHANNEL,
	SET_MASTERNAME, GET_MASTERNAME,
        SET_ROAM_CONFIG, GET_ROAM_CONFIG,
        SET_MAC_OPT, GET_MAC_OPT,
        SET_DEBUG, GET_DEBUG,
        SET_PEER_TO_PEER, GET_PEER_TO_PEER,
        SET_ITO, GET_ITO,
	SET_DISABLE_ROAM, GET_DISABLE_ROAM,
	GET_SYNCSTATE,
	GET_MSTASYNCNAME,
	GET_MSTAADDR,
	GET_MSTASYNCCHANNEL,
	GET_MSTASYNCSUBCHANNEL,
	GET_ROMVERSION,
	SET_ADDR, GET_ADDR,
	GET_CC,
	GET_DRIVERVERSION,
	SET_NODE_OVERRIDE,
	SET_HOP_PERIOD, GET_HOP_PERIOD,
	SET_BFREQ, GET_BFREQ,
	SET_BRIDGING, GET_BRIDGING,
	GET_PROTO_MODE,
	GET_CARD_NAME,
	GET_CARD_CONFIG,
	SEND_PROX_PING,
	START_AP_SEARCH,
	STOP_AP_SEARCH,
	AP_LIST
};

/* above SIOCDEVPRIVATE used by wireless ext to hook commands */
#define SIOCSIPSUBC	SIOCDEVPRIVATE + 1	/* Set subchannel */
#define SIOCGIPSUBC	SIOCDEVPRIVATE + 2	/* Get subchannel */
#define SIOCSIPSTNT	SIOCDEVPRIVATE + 3	/* Set station type */
#define SIOCGIPSTNT	SIOCDEVPRIVATE + 4	/* Get station type */
#define SIOCSIPMNAM	SIOCDEVPRIVATE + 5	/* Set master name */
#define SIOCGIPMNAM	SIOCDEVPRIVATE + 6	/* Get master name */
#define SIOCSIPSECID	SIOCDEVPRIVATE + 7	/* Set security ID */
#define SIOCGIPSECID	SIOCDEVPRIVATE + 8	/* Get security ID */

/* below here should go */
struct rl2_master_opts{
	unsigned char type;
	unsigned char channel;
	unsigned char subchannel;
	unsigned char domain;
	unsigned char hopperiod;
	unsigned char bfreq;
	unsigned char name[12];
	unsigned char deferalslot;
	unsigned char fairnessslot;
	unsigned char bridge;
	unsigned char id[21];
        unsigned char roamconfig;
        unsigned char macoptimize;
        unsigned char debug;
        unsigned char peertopeer;
        unsigned char ITOMin;
        unsigned char ITOSec;
};

struct rl2_master_opts myopts;

enum {RL2RESET, RL2ROAM, RL2INFO, RL2NODETABLE, RL2MASTEROPTS, RL2LISTAPS};

extern struct NodeEntry NodeTable[];
extern unsigned_8 MRUNodeEntry;
extern unsigned_8 LLDSyncState;
extern unsigned_8 LLDMSTASyncChannel;
extern unsigned_8 LLDMSTASyncSubChannel;
extern unsigned_8 LLDDomain;
extern unsigned_8 LLDNodeType;
extern unsigned_8 LLDMSTASyncName[];
extern unsigned_8 LLDMSTAName[];
extern unsigned_8 LLDChannel;
extern unsigned_8 LLDSubChannel;
extern unsigned_8 LLDSecurityID[];
extern unsigned_8 LLDNeedReset;
extern unsigned_8 PacketizePktBuf[];
extern unsigned_8 PacketSeqNum;
extern unsigned_8 LLDRoamingFlag;
extern unsigned_8 LLDBridgeFlag;

